# -*- coding: utf-8 -*-
# == Schema Information
# Schema version: 20090304040015
#
# Table name: displays
#
#  id                    :integer       not null, primary key
#  domain_id             :integer       not null
#  product_id            :integer       not null
#  type                  :string(255)   not null
#  name_po               :integer       not null
#  code                  :string(255)   not null
#  position              :integer
#  enabled               :boolean
#  button_new            :boolean
#  button_edit           :boolean
#  button_delete         :boolean
#  button_copy           :boolean
#  logic_path            :string(255)
#  logic_pre             :boolean
#  logic_mid             :boolean
#  logic_post            :boolean
#  logic_before          :boolean
#  logic_after           :boolean
#  person_id             :integer
#  narrowing_model_name  :string(255)
#  narrowing_column_name :string(255)
#  created_at            :string(14)
#  updated_at            :string(14)
#  created_by            :integer
#  updated_by            :integer
#  created_in            :integer
#  updated_in            :integer
#  lock_version          :integer       default(0), not null
#

# 一覧画面(ユーザ一覧)のモデル
class DisplayToListPrivate < DisplayToList
  validates_presence_of :person_id
  belongs_to :person
  has_many :shared_lists, :foreign_key => "display_id", :order => "created_at desc", :dependent =>:destroy

  # 同じ内容の共有一覧を作成する。
  # 作成に成功した場合は作成された共有一覧を返す。
  def share(roleable)
    conditions = {:display_id => id, :roleable_type => roleable.class.to_s, :roleable_id => roleable.id}
    shared_list = SharedList.find(:first, :conditions => conditions)
    return shared_list if shared_list
    return SharedList.create!(conditions)
  end

  # 情報をコピーした新しい個人一覧 display_to_list_private を返す。
  def export(person_id)
    copy(DisplayToListPrivate, person_id)
  end

  private

  def initialize_button_and_name_and_items
    # nothing to do
  end
end
