# -*- coding: utf-8 -*-
# == Schema Information
# Schema version: 20090304040015
#
# Table name: displays
#
#  id                    :integer       not null, primary key
#  domain_id             :integer       not null
#  product_id            :integer       not null
#  type                  :string(255)   not null
#  name_po               :integer       not null
#  code                  :string(255)   not null
#  position              :integer
#  enabled               :boolean
#  button_new            :boolean
#  button_edit           :boolean
#  button_delete         :boolean
#  button_copy           :boolean
#  logic_path            :string(255)
#  logic_pre             :boolean
#  logic_mid             :boolean
#  logic_post            :boolean
#  logic_before          :boolean
#  logic_after           :boolean
#  person_id             :integer
#  narrowing_model_name  :string(255)
#  narrowing_column_name :string(255)
#  created_at            :string(14)
#  updated_at            :string(14)
#  created_by            :integer
#  updated_by            :integer
#  created_in            :integer
#  updated_in            :integer
#  lock_version          :integer       default(0), not null
#

# 詳細画面のモデル。
class DisplayToShow < Display
  BUTTON_TYPE = [
    [N_("rfw|Display|Edit"), "edit"],
    [N_("rfw|Display|Delete"), "delete"],
    [N_("rfw|Display|Copy"), "copy"],
  ]

  # 種類の名前を返す。
  def type_name
    s_("rfw|Display|Detail")
  end

  # 権限にしたがって利用可能かどうかを判定する。
  def available?
    product.visible?
  end

  # 「閉じる」ボタンの有無を返す。
  def button_close?
    true
  end
end
