# -*- coding: utf-8 -*-
# == Schema Information
# Schema version: 20090304040015
#
# Table name: products
#
#  id                      :integer       not null, primary key
#  domain_id               :integer       not null
#  code                    :string(255)   not null
#  name_po                 :integer       not null
#  motion                  :string(255)
#  parent_id               :integer
#  lft                     :integer
#  rgt                     :integer
#  type                    :string(255)   not null
#  model_name              :string(255)
#  table_name              :string(255)
#  detail_model_name       :string(255)
#  detail_table_name       :string(255)
#  parent_succeeded        :boolean
#  pivot                   :string(255)
#  workflow_enabled        :boolean
#  workflow                :string(255)
#  workflow_body_method    :string(255)
#  mail                    :boolean
#  mail_skip_auth          :boolean
#  document                :boolean
#  document_name_method    :string(255)   default("name")
#  document_number_method  :string(255)   default("id")
#  document_content_method :string(255)   default("name")
#  attachment              :boolean
#  search                  :boolean
#  csv                     :boolean
#  initial_roleable_type   :string(255)
#  scope_roleable_type     :string(255)
#  permission_enabled      :boolean
#  created_at              :string(14)
#  updated_at              :string(14)
#  created_by              :integer
#  updated_by              :integer
#  created_in              :integer
#  updated_in              :integer
#  lock_version            :integer       default(0), not null
#

# プロダクト(単票形式)のモデル。
class ProductSingle < Product
  validates_presence_of :model_name
  after_create :initialize_menu_and_displays

  # 種類を文字列で返す。
  def type_name
    s_("rfw|Product|Type 1")
  end
end
